#include <stdio.h>

#define FAST_CRC16
//#define SLOW_CRC16

extern unsigned short __checksum1;
extern unsigned short __checksum2;
extern unsigned int __checksum_begin1;
extern unsigned int __checksum_end1;
extern unsigned int __checksum_begin2;
extern unsigned int __checksum_end2;

extern unsigned short slow_crc16(unsigned short,unsigned char *,unsigned int);
extern unsigned short fast_crc16(unsigned short,unsigned char *,unsigned int);

const int zero=0;

int main(void)
{
     unsigned short sum1=0;
     unsigned short sum2=0;

#ifdef SLOW_CRC16
     sum1 = slow_crc16(sum1,(unsigned char *)&__checksum_begin1, (unsigned int)&__checksum_end1 -(unsigned int)&__checksum_begin1 +1);
     sum1 = slow_crc16(sum1,(unsigned char *)&zero, 2);
     sum2 = slow_crc16(sum2,(unsigned char *)&__checksum_begin2, (unsigned int)&__checksum_end2 -(unsigned int)&__checksum_begin2 +1);
     sum2 = slow_crc16(sum2,(unsigned char *)&zero, 2);
#elif defined FAST_CRC16
     sum1 = fast_crc16(sum1,(unsigned char *)&__checksum_begin1, (unsigned int)&__checksum_end1 -(unsigned int)&__checksum_begin1 +1);
     sum2 = fast_crc16(sum2,(unsigned char *)&__checksum_begin2, (unsigned int)&__checksum_end2 -(unsigned int)&__checksum_begin2 +1);
#endif

     if (sum1 != __checksum1)
     {
          printf("*** Checksum1 failed: from 0x%hX with this number of bytes 0x%hX \n",((unsigned int *)&__checksum_begin1), ((unsigned int)&__checksum_end1 -(unsigned int)&__checksum_begin1 +1));
          printf("*** Checksum1 failed: 0x%hX (counted) vs 0x%hX (from ielftool)\n", sum1, __checksum1);
     }
     else
     {
          printf("+++ Checksum1 0x%hX is correct!\n", __checksum1);
     }

     if (sum2 != __checksum2)
     {
          printf("*** Checksum2 failed: from 0x%hX with this number of bytes 0x%hX \n",((unsigned int *)&__checksum_begin2), ((unsigned int)&__checksum_end2 -(unsigned int)&__checksum_begin2 +1));
          printf("*** Checksum2 failed: 0x%hX (counted) vs 0x%hX (from ielftool)\n", sum2, __checksum2);
     }
     else
     {
          printf("+++ Checksum2 0x%hX is correct!\n", __checksum2);
     }
}
